package com.kda.data.entities;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import com.kda.data.utils.IdEntidadInterface;

@Entity
@Table(name = "actividad")
public class Actividad implements IdEntidadInterface, Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = -7768458348514937264L;

	@Id
	@GeneratedValue
	private long id;

	@Column(name = "usuarioCreador")
	private long usuarioCreadorId;

	@Column(name = "aficion_id")
	private long aficionId;

	@Column(name = "ubicacion_id")
	private long ubicacionId;

	@Temporal(TemporalType.TIMESTAMP)
	private Date fechaCelebracion;

	private String quedarEn;
	private String descripcion;

	public Actividad() {

	}

	public long getId() {
		return id;
	}

	public void setId(long id) {
		this.id = id;
	}

	public long getUsuarioCreadorId() {
		return usuarioCreadorId;
	}

	public void setUsuarioCreadorId(long usuarioCreadorId) {
		this.usuarioCreadorId = usuarioCreadorId;
	}

	public long getAficionId() {
		return aficionId;
	}

	public void setAficionId(long aficionId) {
		this.aficionId = aficionId;
	}

	public long getUbicacionId() {
		return ubicacionId;
	}

	public void setUbicacionId(long ubicacionId) {
		this.ubicacionId = ubicacionId;
	}

	public Date getFechaCelebracion() {
		return fechaCelebracion;
	}

	public void setFechaCelebracion(Date fechaCelebracion) {
		this.fechaCelebracion = fechaCelebracion;
	}

	public String getQuedarEn() {
		return quedarEn;
	}

	public void setQuedarEn(String quedarEn) {
		this.quedarEn = quedarEn;
	}

	public String getDescripcion() {
		return descripcion;
	}

	public void setDescripcion(String descripcion) {
		this.descripcion = descripcion;
	}

}
