package com.kda.data.managers;

import java.util.Date;
import java.util.List;

import com.kda.data.entities.Actividad;
import com.kda.data.entities.ActividadConDatos;
import com.kda.data.entities.Usuario;

public interface ActividadManager {

	public final static String SERVICIO = "actividadManager";

	public boolean validaDatos(Actividad actividad);

	public boolean guardaDatos(Actividad actividad, Usuario usuario);

	public boolean suscribirseAActividad(Actividad actividad, Usuario usuario);

	public boolean descartarseDeActividad(Actividad actividad, Usuario usuario);

	public Actividad recuperaActividad(Actividad actividad);

	public Actividad recuperaActividad(long actividadId);

	public List<ActividadConDatos> recuperaActividadesUsuarioPosterioresA(
			Usuario usuario, Date fecha);

	public List<ActividadConDatos> recuperaActividadesUsuario(Usuario usuario);

	public List<ActividadConDatos> recuperaActividadesAvisosUsuarioPosterioresA(
			Usuario usuario, Date fecha);

	public ActividadConDatos recuperaActividadConDatos(long actividadId);

}
