package com.kda.data.managers;

import java.io.Serializable;
import java.util.List;

import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;

import com.kda.data.entities.Aficion;
import com.kda.data.entities.AgrupacionAficiones;
import com.kda.data.utils.PersistenceUtil;

@ManagedBean(name = "aficionManager")
@SessionScoped
public class AficionManagerImpl implements AficionManager, Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 2018252202837885806L;

	public AficionManagerImpl() {
	}

	@Override
	public Aficion recuperaAficion(AgrupacionAficiones agrupacion, int id) {
		PersistenceUtil persistenceUtil = new PersistenceUtil(true);
		Aficion aficion = null;
		try {
			aficion = persistenceUtil
					.consulta(
							"select p from Aficion p where p.agrupacion_id=:agrupacion_id and p.id=:id")
					.addParametro("agrupacion_id", agrupacion.getId())
					.addParametro("id", id).single(Aficion.class);
		} finally {
			persistenceUtil.finalizaTransaccion();
		}
		return aficion;
	}

	@Override
	public List<Aficion> cargaAficiones(AgrupacionAficiones agrupacion) {
		PersistenceUtil persistenceUtil = new PersistenceUtil(true);
		List<Aficion> aficion = null;
		try {
			aficion = persistenceUtil
					.consulta(
							"select p from Aficion p where p.agrupacion_id=:agrupacion_id")
					.addParametro("agrupacion_id", agrupacion.getId())
					.multi(Aficion.class);
		} finally {
			persistenceUtil.finalizaTransaccion();
		}
		return aficion;
	}

	@Override
	public Aficion cargaAficion(long aficionId) {
		PersistenceUtil persistenceUtil = new PersistenceUtil(true);
		Aficion aficion = new Aficion();
		aficion.setId(aficionId);
		try {
			aficion = persistenceUtil.getEntityManager().find(Aficion.class,
					aficion);
		} finally {
			persistenceUtil.finalizaTransaccion();
		}
		return aficion;
	}

	@Override
	public List<Aficion> cargaTodasLasAficiones() {
		PersistenceUtil persistenceUtil = new PersistenceUtil(true);
		List<Aficion> aficion = null;
		try {
			aficion = persistenceUtil.consulta("select p from Aficion p")
					.multi(Aficion.class);
		} finally {
			persistenceUtil.finalizaTransaccion();
		}
		return aficion;
	}

}
