package com.kda.data.managers;

import java.io.Serializable;
import java.util.List;

import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;

import com.kda.data.entities.AgrupacionAficiones;
import com.kda.data.utils.PersistenceUtil;

@ManagedBean(name = "agrupacionAficionesManager")
@SessionScoped
public class AgrupacionAficionesManagerImpl implements
		AgrupacionAficionesManager, Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 2018252202837885806L;

	public AgrupacionAficionesManagerImpl() {
	}

	@Override
	public AgrupacionAficiones recuperaAgrupacion(int id) {
		PersistenceUtil persistenceUtil = new PersistenceUtil(true);
		AgrupacionAficiones agrupacionAficiones = null;
		try {
			agrupacionAficiones = persistenceUtil
					.consulta(
							"select p from AgrupacionAficiones p where p.id=:id")
					.addParametro("id", id).single(AgrupacionAficiones.class);
		} finally {
			persistenceUtil.finalizaTransaccion();
		}
		return agrupacionAficiones;
	}

	@Override
	public List<AgrupacionAficiones> cargaTodasLasAgrupaciones() {
		PersistenceUtil persistenceUtil = new PersistenceUtil(false);
		List<AgrupacionAficiones> agrupacionAficiones = null;
		try {
			agrupacionAficiones = persistenceUtil.consulta(
					"select p from AgrupacionAficiones p").multi(
					AgrupacionAficiones.class);
		} finally {
			persistenceUtil.finalizaTransaccion();
		}
		return agrupacionAficiones;
	}

}
