package com.kda.data.managers;

import java.io.Serializable;
import java.util.List;

import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;

import com.kda.data.entities.Provincia;
import com.kda.data.utils.PersistenceUtil;

@ManagedBean(name = "provinciasManager")
@SessionScoped
public class ProvinciasManagerImpl implements ProvinciasManager, Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 2018252202837885806L;

	public ProvinciasManagerImpl() {
	}

	@Override
	public Provincia recuperaProvincia(int id) {
		PersistenceUtil persistenceUtil = new PersistenceUtil(true);
		Provincia provincia = null;
		try {
			provincia = persistenceUtil
					.consulta("select p from Provincia p where p.id=:id")
					.addParametro("id", id).single(Provincia.class);
		} finally {
			persistenceUtil.finalizaTransaccion();
		}
		return provincia;
	}

	@Override
	public List<Provincia> cargaTodasLasProvincias() {
		PersistenceUtil persistenceUtil = new PersistenceUtil(false);
		List<Provincia> provincia = null;
		try {
			provincia = persistenceUtil.consulta(
					"select p from Provincia p order by p.provincia").multi(
					Provincia.class);
		} finally {
			persistenceUtil.finalizaTransaccion();
		}
		return provincia;
	}

}
