package com.kda.data.managers;

import java.io.Serializable;
import java.util.List;

import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;

import com.kda.data.entities.Provincia;
import com.kda.data.entities.Ubicacion;
import com.kda.data.utils.PersistenceUtil;

@ManagedBean(name = "ubicacionManager")
@SessionScoped
public class UbicacionManagerImpl implements UbicacionManager, Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 2018252202837885806L;

	public UbicacionManagerImpl() {
	}

	@Override
	public Ubicacion recuperaUbicacion(Provincia provincia, int id) {
		PersistenceUtil persistenceUtil = new PersistenceUtil(true);
		Ubicacion ubicacion = null;
		try {
			ubicacion = persistenceUtil
					.consulta(
							"select p from Ubicacion p where p.idProvincia=:idProvincia and p.id=:id")
					.addParametro("idProvincia", provincia.getId())
					.addParametro("id", id).single(Ubicacion.class);
		} finally {
			persistenceUtil.finalizaTransaccion();
		}
		return ubicacion;
	}

	@Override
	public List<Ubicacion> cargaUbicacion(Provincia provincia) {
		PersistenceUtil persistenceUtil = new PersistenceUtil(true);
		List<Ubicacion> ubicacion = null;
		try {
			ubicacion = persistenceUtil
					.consulta(
							" select p from Ubicacion p "
									+ " where p.idProvincia=:idProvincia order by p.poblacion")
					.addParametro("idProvincia", provincia.getId())
					.multi(Ubicacion.class);
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			persistenceUtil.finalizaTransaccion();
		}
		return ubicacion;
	}

	@Override
	public List<Ubicacion> cargaTodasLasUbicaciones() {
		PersistenceUtil persistenceUtil = new PersistenceUtil(true);
		List<Ubicacion> ubicacion = null;
		try {
			ubicacion = persistenceUtil.consulta(
					"select p from Ubicacion p order by nombre").multi(
					Ubicacion.class);
		} finally {
			persistenceUtil.finalizaTransaccion();
		}
		return ubicacion;
	}

}
