package com.kda.data.utils;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.TemporalType;

public class QrySimple {

	private Query query;

	public QrySimple(Query query) {
		this.query = query;
	}

	public QrySimple addParametro(String parametro, Object valor) {
		query.setParameter(parametro, valor);
		return this;
	}

	public QrySimple addParametro(String parametro, java.util.Date valor,
			TemporalType tipo) {
		query.setParameter(parametro, valor, tipo);
		return this;
	}

	@SuppressWarnings("unchecked")
	public <T> T single(Class<T> objeto) {
		try {
			return (T) query.getSingleResult();
		} catch (NoResultException nre) {
			return null;
		}
	}

	@SuppressWarnings("unchecked")
	public <T> List<T> multi(Class<T> objeto) {
		return (List<T>) query.getResultList();
	}
}
