package com.kda.display.controlers;

import java.io.Serializable;
import java.util.List;

import javax.annotation.PostConstruct;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ManagedProperty;
import javax.faces.bean.SessionScoped;
import javax.faces.event.ActionEvent;

import com.kda.data.entities.Usuario;
import com.kda.data.managers.SesionManager;
import com.kda.utils.Constantes;
import com.kda.utils.ObjetoMap;

@ManagedBean
@SessionScoped
public class CabeceraControler extends BaseControler implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1589851743584657030L;

	String mail;
	String password;
	String mensaje;

	boolean mostrarLogin = true;
	boolean errorLogin = false;
	String tipoAccion;

	@ManagedProperty(value = "#{sesionManager}")
	SesionManager sesionManager;

	public CabeceraControler() {
	}

	@PostConstruct
	public void cargaPantalla() {
		if (this.sesionManager.isUsuarioLogado()) {
			this.mostrarLogin = false;
		} else {
			this.mostrarLogin = true;
		}
	}

	public void opcionMenu(ActionEvent actionEvent) {
		mostrarLogin = true;
	}

	public String accion() {
		String resultado = "";
		this.mostrarLogin = false;
		this.errorLogin = false;

		if ("unirse".equals(this.tipoAccion)) {
			resultado = Constantes.PAGINA_DATOS_USUARIO;
		} else if ("logout".equals(this.tipoAccion)) {
			this.sesionManager.logout();
			resultado = Constantes.PAGINA_HOME;
		} else if ("pizarra".equals(this.tipoAccion)) {
			resultado = Constantes.PAGINA_PIZARRA;
		}
		if (this.sesionManager.getUsuario() == null
				|| this.sesionManager.getUsuario().getMail() == null) {
			this.mostrarLogin = true;
		}
		return resultado;
	}

	public String login() {
		this.errorLogin = true;
		boolean logado = this.sesionManager.login(mail, password);
		if (logado) {
			this.mostrarLogin = false;
			return Constantes.PAGINA_PIZARRA;
		} else {
			this.mensaje = super.getLiteral("errorEnLogin");
			this.errorLogin = true;
			return Constantes.PAGINA_HOME;
		}
	}

	public String logout() {
		boolean logado = false;

		if (logado) {
			this.mostrarLogin = false;
			return Constantes.PAGINA_PIZARRA;
		} else {
			this.mensaje = super.getLiteral("errorEnLogin");
			this.sesionManager.logout();
			return Constantes.PAGINA_HOME;
		}
	}

	@SuppressWarnings("unused")
	public void login(ActionEvent event) {
		boolean logado = this.sesionManager.login(mail, password);
		// if (logado) {
		// return "pizarra";
		// } else {
		// this.mensaje = super.getLiteral("errorEnLogin");
		// return "";
		// }
	}

	public List<ObjetoMap> getOpciones() {
		return super.getLista(this.sesionManager.getOpcionesPermitidas());
	}

	public Usuario getUsuario() {
		return this.sesionManager.getUsuario();
	}

	public String getMail() {
		return mail;
	}

	public void setMail(String mail) {
		this.mail = mail;
	}

	public String getPassword() {
		return password;
	}

	public void setPassword(String password) {
		this.password = password;
	}

	public String getMensaje() {
		return mensaje;
	}

	public void setMensaje(String mensaje) {
		this.mensaje = mensaje;
	}

	public void setSesionManager(SesionManager sesionManager) {
		this.sesionManager = sesionManager;
	}

	public boolean isMostrarLogin() {
		if (this.sesionManager.isUsuarioLogado()) {
			mostrarLogin = false;
		} else {
			mostrarLogin = true;
		}
		return mostrarLogin;
	}

	public void setMostrarLogin(boolean mostrarLogin) {
		this.mostrarLogin = mostrarLogin;
	}

	public String getTipoAccion() {
		return tipoAccion;
	}

	public void setTipoAccion(String tipoAccion) {
		this.tipoAccion = tipoAccion;
	}

	public boolean isErrorLogin() {
		return errorLogin;
	}

	public void setErrorLogin(boolean errorLogin) {
		this.errorLogin = errorLogin;
	}
}
