package com.kda.display.controlers;

import java.io.Serializable;

import javax.annotation.PostConstruct;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ManagedProperty;
import javax.faces.bean.ViewScoped;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;

import com.kda.data.entities.Actividad;
import com.kda.data.managers.ActividadManager;
import com.kda.data.managers.AficionManager;
import com.kda.data.managers.SesionManager;
import com.kda.data.managers.UbicacionManager;
import com.kda.data.managers.UsuarioManager;
import com.kda.display.forms.DatosActividadForm;
import com.kda.display.forms.DatosUsuarioForm;
import com.kda.utils.Constantes;

@ManagedBean
@ViewScoped
public class DatosActividadControler extends BaseControler implements
		Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 5320653523068647752L;

	private DatosActividadForm datosActividadForm;

	@ManagedProperty(value = "#{sesionManager}")
	SesionManager sesionManager;

	@ManagedProperty(value = "#{usuarioManager}")
	UsuarioManager usuarioManager;

	@ManagedProperty(value = "#{aficionManager}")
	AficionManager aficionManager;

	@ManagedProperty(value = "#{actividadManager}")
	ActividadManager actividadManager;

	@ManagedProperty(value = "#{ubicacionManager}")
	UbicacionManager ubicacionManager;

	private String actividadId;

	Actividad actividad = new Actividad();

	public DatosActividadControler() {

	}

	@PostConstruct
	public void cargaPantalla() {
		FacesContext facesContext = FacesContext.getCurrentInstance();
		this.actividadId = facesContext.getExternalContext()
				.getRequestParameterMap().get("actividadId");
		datosActividadForm = new DatosActividadForm();
		if (this.actividadId == null
				|| (this.actividad != null && "".equals(this.actividadId))) {
			this.actividad = new Actividad();
		} else {
			this.actividad = this.actividadManager.recuperaActividad(Integer
					.valueOf(this.actividadId));
		}
		datosActividadForm.toForm(this.actividad, this.getSesionManager()
				.getUsuario());
	}

	public String cargaDatos() {
		String resultado = Constantes.PAGINA_DATOS_ACTIVIDAD;
		return resultado;
	}

	public void guardaDatos(ActionEvent actionEvent) {
		Actividad actividad = datosActividadForm.toObject(null);
		actividadManager
				.guardaDatos(actividad, this.sesionManager.getUsuario());
	}

	public String guardaDatos() {
		Actividad actividad = datosActividadForm.toObject(null);
		boolean resultado = actividadManager.guardaDatos(actividad,
				this.sesionManager.getUsuario());
		return Constantes.PAGINA_PIZARRA + "?faces-redirect=true";
	}

	public DatosUsuarioForm getDatosUsuarioForm() {
		return datosUsuarioForm;
	}

	public void setDatosUsuarioForm(DatosUsuarioForm datosUsuarioForm) {
		this.datosUsuarioForm = datosUsuarioForm;
	}

	public void setUsuarioManager(UsuarioManager usuarioManager) {
		this.usuarioManager = usuarioManager;
	}

	public SesionManager getSesionManager() {
		return sesionManager;
	}

	public void setSesionManager(SesionManager sesionManager) {
		this.sesionManager = sesionManager;
	}

	public ActividadManager getActividadManager() {
		return actividadManager;
	}

	public void setActividadManager(ActividadManager actividadManager) {
		this.actividadManager = actividadManager;
	}

	public AficionManager getAficionManager() {
		return aficionManager;
	}

	public void setAficionManager(AficionManager aficionManager) {
		this.aficionManager = aficionManager;
	}

	public UsuarioManager getUsuarioManager() {
		return usuarioManager;
	}

	public UbicacionManager getUbicacionManager() {
		return ubicacionManager;
	}

	public void setUbicacionManager(UbicacionManager ubicacionManager) {
		this.ubicacionManager = ubicacionManager;
	}

	public DatosActividadForm getDatosActividadForm() {
		return datosActividadForm;
	}

	public void setDatosActividadForm(DatosActividadForm datosActividadForm) {
		this.datosActividadForm = datosActividadForm;
	}

	public String getActividadId() {
		return actividadId;
	}

	public void setActividadId(String actividadId) {
		this.actividadId = actividadId;
	}

	public Actividad getActividad() {
		return actividad;
	}

	public void setActividad(Actividad actividad) {
		this.actividad = actividad;
	}
}
