package com.kda.display.forms;

import java.io.Serializable;
import java.util.Date;

import com.kda.data.entities.ComentarioActividadConDatos;
import com.kda.data.entities.Usuario;

public class ComentarioActividadForm implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 6487640530577644733L;

	private long actividadId;
	private long usuarioId;
	private String nombreAficion;
	private Date fechaActividad;
	private String descripcionActividad;
	private String comentario;

	public ComentarioActividadConDatos toObject(
			ComentarioActividadConDatos comentarioActividad) {
		if (comentarioActividad == null) {
			comentarioActividad = new ComentarioActividadConDatos();
		}
		comentarioActividad.setActividadId(getActividadId());
		comentarioActividad.setNombreAficion(getNombreAficion());
		comentarioActividad.setFecha(new Date());
		comentarioActividad.setComentario(getComentario());
		comentarioActividad.setUsuarioCreadorId(getUsuarioId());
		comentarioActividad.setDescripcionActividad(getDescripcionActividad());

		return comentarioActividad;
	}

	public void toForm(ComentarioActividadConDatos comentarioActividad,
			Usuario usuario) {
		setActividadId(comentarioActividad.getActividadId());
		setNombreAficion(comentarioActividad.getNombreAficion());
		setFechaActividad(comentarioActividad.getFechaCelebracionActividad());
		setComentario(comentarioActividad.getComentario());
		setDescripcionActividad(comentarioActividad.getDescripcionActividad());
		setUsuarioId(usuario.getId());
	}

	public void reset() {
		setActividadId(0);
		setNombreAficion("");
		setFechaActividad(new Date(0));
		setComentario("");
		setUsuarioId(0);
	}

	public long getActividadId() {
		return actividadId;
	}

	public void setActividadId(long actividadId) {
		this.actividadId = actividadId;
	}

	public long getUsuarioId() {
		return usuarioId;
	}

	public void setUsuarioId(long usuarioId) {
		this.usuarioId = usuarioId;
	}

	public String getNombreAficion() {
		return nombreAficion;
	}

	public void setNombreAficion(String nombreAficion) {
		this.nombreAficion = nombreAficion;
	}

	public Date getFechaActividad() {
		return fechaActividad;
	}

	public void setFechaActividad(Date fechaActividad) {
		this.fechaActividad = fechaActividad;
	}

	public String getComentario() {
		return comentario;
	}

	public void setComentario(String comentario) {
		this.comentario = comentario;
	}

	public String getDescripcionActividad() {
		return descripcionActividad;
	}

	public void setDescripcionActividad(String descripcionActividad) {
		this.descripcionActividad = descripcionActividad;
	}

}