package com.kda.display.forms;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

import javax.faces.model.SelectItem;

import com.kda.data.entities.Actividad;
import com.kda.data.entities.Usuario;

public class DatosActividadForm implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 6487640530577644733L;

	private long actividadId;

	private long usuarioId;
	private long aficionId;
	private long ubicacionId;

	private Date fechaCelebracion;
	private String quedarEn;
	private String descripcion;

	private List<SelectItem> aficiones;
	private List<SelectItem> ubicaciones;

	public Actividad toObject(Actividad actividad) {
		if (actividad == null) {
			actividad = new Actividad();
		}
		actividad.setAficionId(getAficionId());
		actividad.setDescripcion(getDescripcion());
		actividad.setQuedarEn(getQuedarEn());
		actividad.setUbicacionId(getUbicacionId());
		actividad.setFechaCelebracion(new java.util.Date(getFechaCelebracion()
				.getTime()));
		actividad.setUsuarioCreadorId(getUsuarioId());
		return actividad;
	}

	public void toForm(Actividad actividad, Usuario usuario) {
		setUsuarioId(usuario.getId());
		setFechaCelebracion(actividad.getFechaCelebracion());
		setQuedarEn(actividad.getQuedarEn());
		setDescripcion(actividad.getDescripcion());
		setAficiones(AficionesForm.getAficiones(usuario.getAficiones()));
		setUbicaciones(UbicacionesForm.getUbicaciones(usuario.getUbicaciones()));
	}

	public void reset() {
		setFechaCelebracion(new Date(0));
		setQuedarEn("");
		setDescripcion("");
		setAficiones(null);
		setUbicaciones(null);
	}

	public long getUsuarioId() {
		return usuarioId;
	}

	public void setUsuarioId(long usuarioId) {
		this.usuarioId = usuarioId;
	}

	public long getAficionId() {
		return aficionId;
	}

	public void setAficionId(long aficionId) {
		this.aficionId = aficionId;
	}

	public long getUbicacionId() {
		return ubicacionId;
	}

	public void setUbicacionId(long ubicacionId) {
		this.ubicacionId = ubicacionId;
	}

	public Date getFechaCelebracion() {
		return fechaCelebracion;
	}

	public void setFechaCelebracion(Date fechaCelebracion) {
		this.fechaCelebracion = fechaCelebracion;
	}

	public String getQuedarEn() {
		return quedarEn;
	}

	public void setQuedarEn(String quedarEn) {
		this.quedarEn = quedarEn;
	}

	public String getDescripcion() {
		return descripcion;
	}

	public void setDescripcion(String descripcion) {
		this.descripcion = descripcion;
	}

	public List<SelectItem> getAficiones() {
		return aficiones;
	}

	public void setAficiones(List<SelectItem> aficiones) {
		this.aficiones = aficiones;
	}

	public List<SelectItem> getUbicaciones() {
		return ubicaciones;
	}

	public void setUbicaciones(List<SelectItem> ubicaciones) {
		this.ubicaciones = ubicaciones;
	}

	public long getActividadId() {
		return actividadId;
	}

	public void setActividadId(long actividadId) {
		this.actividadId = actividadId;
	}
}